// Form1.h (Test Client)

#pragma once

#include "WcfShareTestClient.h"

namespace WcfShareTest {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
  using namespace System::ServiceModel;
  using namespace System::Diagnostics;
  using namespace System::IO;
  using namespace System::Threading;

	/// <summary>
	/// Zusammenfassung fr Form1
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
  public:
    Form1(void)  // Test Client
    {
      InitializeComponent();
      //
      //TODO: Konstruktorcode hier hinzufgen.
      //

      lblGuiThreadId->Text = String::Format("GUI thread ID: {0}", Thread::CurrentThread->ManagedThreadId);
      bool bClientObjectValid = false;
      try {
        EventWaitHandle ^evt = gcnew EventWaitHandle(false, EventResetMode::ManualReset, "WcfShareTestServerLaunchedEvent");
        if (!evt->WaitOne(0)) {  // This means the server isn't running yet, so start it
          Process ^proc = Process::Start(Path::Combine(Application::StartupPath, "TestServer.exe"));
          Trace::Assert(proc != nullptr, "WCF Share Test: Failed to launch TestServer");
          Trace::Assert(evt->WaitOne(10000), "WCF Share Test: Wait for TestServer start-up timed out");
          proc->Close();
        }
        evt->Close();
        m_client = gcnew TestServer::TestServerClient;
        m_nInstanceNumber = m_client->GetClientInstanceNumber();
        Text += String::Format(" #{0}", m_nInstanceNumber);
      }
      catch (Exception ^e) {
        MessageBox::Show(String::Format("Client object instantiation or server connection failed: {0}", e),
          Text, MessageBoxButtons::OK, MessageBoxIcon::Error);
        groupBox1->Enabled = false;
      }
    }

  protected:
    /// <summary>
    /// Verwendete Ressourcen bereinigen.
    /// </summary>
    ~Form1()  // Test Client
    {
      if (m_client && m_client->State != CommunicationState::Faulted) {
        m_client->Detach(m_nInstanceNumber);
        m_client->Close();
      }

      if (components)
      {
        delete components;
      }
    }

  private:
    TestServer::TestServerClient ^m_client;
    int m_nInstanceNumber;

  private: System::Windows::Forms::Label^  lblGuiThreadId;
  protected: 
  private: System::Windows::Forms::GroupBox^  groupBox1;
  private: System::Windows::Forms::Button^  bnSetSharedData;
  private: System::Windows::Forms::Button^  bnGetSharedData;
  private: System::Windows::Forms::TextBox^  txtSharedData;

	private:
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung.
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		void InitializeComponent(void)
		{
      this->lblGuiThreadId = (gcnew System::Windows::Forms::Label());
      this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
      this->bnSetSharedData = (gcnew System::Windows::Forms::Button());
      this->bnGetSharedData = (gcnew System::Windows::Forms::Button());
      this->txtSharedData = (gcnew System::Windows::Forms::TextBox());
      this->groupBox1->SuspendLayout();
      this->SuspendLayout();
      // 
      // lblGuiThreadId
      // 
      this->lblGuiThreadId->AutoSize = true;
      this->lblGuiThreadId->Location = System::Drawing::Point(12, 9);
      this->lblGuiThreadId->Name = L"lblGuiThreadId";
      this->lblGuiThreadId->Size = System::Drawing::Size(35, 13);
      this->lblGuiThreadId->TabIndex = 0;
      this->lblGuiThreadId->Text = L"label1";
      // 
      // groupBox1
      // 
      this->groupBox1->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Left) 
        | System::Windows::Forms::AnchorStyles::Right));
      this->groupBox1->Controls->Add(this->bnSetSharedData);
      this->groupBox1->Controls->Add(this->bnGetSharedData);
      this->groupBox1->Controls->Add(this->txtSharedData);
      this->groupBox1->Location = System::Drawing::Point(12, 25);
      this->groupBox1->Name = L"groupBox1";
      this->groupBox1->Size = System::Drawing::Size(268, 77);
      this->groupBox1->TabIndex = 1;
      this->groupBox1->TabStop = false;
      this->groupBox1->Text = L"Shared data";
      // 
      // bnSetSharedData
      // 
      this->bnSetSharedData->Location = System::Drawing::Point(87, 45);
      this->bnSetSharedData->Name = L"bnSetSharedData";
      this->bnSetSharedData->Size = System::Drawing::Size(75, 23);
      this->bnSetSharedData->TabIndex = 2;
      this->bnSetSharedData->Text = L"&Set";
      this->bnSetSharedData->UseVisualStyleBackColor = true;
      this->bnSetSharedData->Click += gcnew System::EventHandler(this, &Form1::bnSetSharedData_Click);
      // 
      // bnGetSharedData
      // 
      this->bnGetSharedData->Location = System::Drawing::Point(6, 45);
      this->bnGetSharedData->Name = L"bnGetSharedData";
      this->bnGetSharedData->Size = System::Drawing::Size(75, 23);
      this->bnGetSharedData->TabIndex = 1;
      this->bnGetSharedData->Text = L"&Get";
      this->bnGetSharedData->UseVisualStyleBackColor = true;
      this->bnGetSharedData->Click += gcnew System::EventHandler(this, &Form1::bnGetSharedData_Click);
      // 
      // txtSharedData
      // 
      this->txtSharedData->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Left) 
        | System::Windows::Forms::AnchorStyles::Right));
      this->txtSharedData->Location = System::Drawing::Point(6, 19);
      this->txtSharedData->Name = L"txtSharedData";
      this->txtSharedData->Size = System::Drawing::Size(256, 20);
      this->txtSharedData->TabIndex = 0;
      // 
      // Form1
      // 
      this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
      this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
      this->ClientSize = System::Drawing::Size(292, 114);
      this->Controls->Add(this->groupBox1);
      this->Controls->Add(this->lblGuiThreadId);
      this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
      this->MaximizeBox = false;
      this->Name = L"Form1";
      this->Text = L"WCF Share Test Client";
      this->groupBox1->ResumeLayout(false);
      this->groupBox1->PerformLayout();
      this->ResumeLayout(false);
      this->PerformLayout();

    }
#pragma endregion

  // Event handlers

  private:
    System::Void bnGetSharedData_Click(System::Object^  sender, System::EventArgs^  e);
    System::Void bnSetSharedData_Click(System::Object^  sender, System::EventArgs^  e);
};
}

